## supernovas 1.0.1

=== Makefile ===

# ===============================================================================
# WARNING! You should leave this Makefile alone probably
#          To configure the build, you can edit config.mk, or else you export the 
#          equivalent shell variables prior to invoking 'make' to adjust the
#          build configuration. 
# ===============================================================================

include config.mk

# ===============================================================================
# Specific build targets and recipes below...
# ===============================================================================

# The version of the shared .so libraries
SO_VERSION := 1

# The documentation components to build
DOC_TARGETS := README-orig.md

# Check if there is a doxygen we can run
ifndef DOXYGEN
  DOXYGEN := $(shell which doxygen)
else
  $(shell test -f $(DOXYGEN))
endif

# If there is doxygen, build the API documentation also by default
ifeq ($(.SHELLSTATUS),0)
  DOC_TARGETS += local-dox
else
  $(info WARNING! Doxygen is not available. Will skip 'dox' target) 
endif

SOLSYS_TARGETS :=
SHARED_TARGETS := lib/libsupernovas.so lib/libnovas.so

ifneq ($(BUILTIN_SOLSYS1),1)
  SOLSYS_TARGETS += obj/solsys1.o obj/eph_manager.o
  SHARED_TARGETS += lib/libsolsys1.so
endif

ifneq ($(BUILTIN_SOLSYS2),1)
  SOLSYS_TARGETS += obj/solsys2.o
  SHARED_TARGETS += lib/libsolsys2.so
endif

ifneq ($(BUILTIN_SOLSYS3),1)
  SOLSYS_TARGETS += obj/solsys3.o
  SHARED_TARGETS += lib/libsolsys3.so
endif

ifneq ($(BUILTIN_SOLSYS_EPHEM),1)
  SOLSYS_TARGETS += obj/solsys-ephem.o
  SHARED_TARGETS += lib/libsolsys-ephem.so
endif

# Default target for packaging with Linux distributions
.PHONY: distro
distro: $(SHARED_TARGETS) cio_ra.bin $(DOC_TARGETS)

# Shared libraries (versioned and unversioned)
.PHONY: shared
shared: $(SHARED_TARGETS)

# Legacy static libraries (locally built)
.PHONY: static
static: lib/libnovas.a solsys

# solarsystem() call handler objects
.PHONY: solsys
solsys: $(SOLSYS_TARGETS)

# All of the above
.PHONY: all
all: distro static test coverage check

# Run regression tests
.PHONY: test
test:
	make -C test run

# Measure test coverage (on test set of files only)
.PHONY: coverage
coverage:
	make -C test coverage

# Remove intermediates
.PHONY: clean
clean:
	rm -f obj README-orig.md bin/cio_file gmon.out
	make -C test clean

# Remove all generated files
.PHONY: distclean
distclean: clean
	rm -f lib cio_ra.bin


# ----------------------------------------------------------------------------
# The nitty-gritty stuff below
# ----------------------------------------------------------------------------

# Unversioned shared libs (for linking against)
lib/lib%.so:
	ln -sr $< $@

lib/libsupernovas.so: lib/libsupernovas.so.$(SO_VERSION)

lib/libsolsys1.so: lib/libsolsys1.so.$(SO_VERSION)

lib/libsolsys2.so: lib/libsolsys2.so.$(SO_VERSION)

lib/libnovas.so: lib/libsupernovas.so

SO_LINK := $(LDFLAGS) -lm

# Share librarry recipe
lib/%.so.$(SO_VERSION) : | lib
	$(CC) -o $@ $(CPPFLAGS) $(CFLAGS) $^ -shared -fPIC -Wl,-soname,$(subst lib/,,$@) $(SO_LINK)

lib/libsolsys%.so.$(SO_VERSION): SO_LINK += -Llib -lsupernovas

# Shared library: supernovas.so -- same as novas.so except the builtin SONAME
lib/libsupernovas.so.$(SO_VERSION): $(SOURCES)

# Shared library: solsys1.so (standalone solsys1.c functionality)
lib/libsolsys1.so.$(SO_VERSION): BUILTIN_SOLSYS1 := 0
lib/libsolsys1.so.$(SO_VERSION): $(SRC)/solsys1.c $(SRC)/eph_manager.c | lib/libsupernovas.so

# Shared library: solsys2.so (standalone solsys2.c functionality)
lib/libsolsys2.so.$(SO_VERSION): BUILTIN_SOLSYS2 := 0
lib/libsolsys2.so.$(SO_VERSION): $(SRC)/solsys2.c | lib/libsupernovas.so

# Shared library: solsys1.so (standalone solsys1.c functionality)
lib/libsolsys3.so.$(SO_VERSION): BUILTIN_SOLSYS3 := 0
lib/libsolsys3.so.$(SO_VERSION): $(SRC)/solsys3.c | lib/libsupernovas.so

# Shared library: solsys2.so (standalone solsys2.c functionality)
lib/libsolsys-ephem.so.$(SO_VERSION): BUILTIN_SOLSYS_EPHEM := 0
lib/libsolsys-ephem.so.$(SO_VERSION): $(SRC)/solsys-ephem.c | lib/libsupernovas.so


# Static library: novas.a
lib/libnovas.a: $(OBJECTS) | lib
	ar -rc $@ $^
	ranlib $@

# CIO locator data
.PHONY: cio_ra.bin
cio_ra.bin: bin/cio_file lib/libnovas.a data/CIO_RA.TXT
	bin/cio_file data/CIO_RA.TXT $@

.INTERMEDIATE: bin/cio_file
bin/cio_file: obj/cio_file.o | bin
	$(CC) -o $@ $(CPPFLAGS) $(CFLAGS) $^ $(LDFLAGS)

README-orig.md: README.md
	LINE=`sed -n '/\# /{=;q;}' $<` && tail -n +$$((LINE+2)) $< > $@

dox: README-orig.md

.INTERMEDIATE: Doxyfile.local
Doxyfile.local:
	sed "s:resources/header.html::g" Doxyfile > $@

# Local documentation without specialized headers. The resulting HTML documents do not have
# Google Search or Analytics tracking info.
local-dox: README-orig.md Doxyfile.local
	doxygen Doxyfile.local


.PHONY: help
help:
	@echo
	@echo "Syntax: make [target]"
	@echo
	@echo "The following targets are available:"
	@echo
	@echo "  distro        (default) 'shared', 'cio_ra.bin' targets, and also 'dox'" 
	@echo "                if 'doxygen' is available, or was specified via the DOXYGEN"
	@echo "                variable (e.g. in 'config.mk')."
	@echo "  static        Builds the static 'lib/libsupernovas.a' library."
	@echo "  shared        Builds the shared 'libsupernovas.so', 'libsolsys1.so', and" 
	@echo "                'libsolsys2.so' libraries (linked to versioned ones)."
	@echo "  cio_ra.bin    Generates the CIO locator lookup data file 'cio_ra.bin', in the"
	@echo "                destination specified in 'config.mk'."
	@echo "  local-dox     Compiles local HTML API documentation using 'doxygen'."
	@echo "  solsys        Builds only the objects that may provide external 'solarsystem()'"
	@echo "                call implentations (e.g. 'solsys1.o', 'eph_manager.o'...)."
	@echo "  check         Performs static analysis with 'cppcheck'."
	@echo "  test          Runs regression tests."
	@echo "  coverage      Runs 'gcov' to analyze regression test coverage."
	@echo "  all           All of the above."
	@echo "  clean         Removes intermediate products."
	@echo "  distclean     Deletes all generated files."
	@echo

Makefile: config.mk build.mk

vpath %.c $(SRC)

# ===============================================================================
# Generic targets and recipes below...
# ===============================================================================

include build.mk

=== test/Makefile ===
# Adjusted configuration for test builds
BUILTIN_SOLSYS3 := 0 
BUILTIN_DEFAULT_SOLSYS := 0 
CIO_LOCATOR_FILE := cio_ra.bin

# Use above config in sub-makes also
export BUILTIN_SOLSYS3 BUILTIN_DEFAULT_SOLSYS CIO_LOCATOR_FILE

CFLAGS += -I../include -g -pg -fprofile-arcs -ftest-coverage
LDFLAGS += -fprofile-arcs -ftest-coverage -lm

include ../config.mk

#OBJECTS := $(subst obj/,,$(OBJECTS))
OBJECTS := novas.o nutation.o solsys3.o

.PHONY: run
run: clean-cov clean-data test-compat test-cio_file test-super test-errors data ../cio_ra.bin
	./test-compat
	ln -s ../cio_ra.bin
	./test-cio_file
	sed -i "s:-nan: nan:g" data/*
	diff data reference
	./test-super
	rm -f cio_ra.bin
	./test-errors

cov: cov.info
	genhtml $< -o $@

cov.info:
	geninfo . -b . -o $@

.PHONY: coverage
coverage: novas.c.gcov nutation.c.gcov solsys3.c.gcov
	make clean-test
	make cov

data:
	mkdir data

.PRECIOUS: %.c.gcov
%.c.gcov: %.gcno %.gcda
	gcov -b $*

.PRECIOUS: %.gcno %.gcda
%.gcno %.gcda: ../src/%.c
	make clean
	make run

../cio_ra.bin:
	make -C .. cio_ra.bin

test-%: test-%.o $(OBJECTS) | Makefile data
	$(CC) -o $@ $^ $(LDFLAGS)

test-%.o: src/test-%.c | Makefile
	$(CC) -c -o $@ $(CPPFLAGS) $(CFLAGS) $<

%.o: ../src/%.c | Makefile
	$(CC) -c -o $@ $(CPPFLAGS) $(CFLAGS) $<

.PHONY: clean-test
clean-test:
	rm -f test-*

.PHONY: clean-cov
clean-cov:
	rm -rf gmon.out *.gcov *.gcda *.gcno cov cov.info

.PHONY: clean-data
clean-data:
	rm -rf data cio_ra.bin

.PHONY: clean
clean: clean-test clean-cov clean-data
	rm -f *.o

vpath %.c ../src
vpath %.c src

## supernovas 1.0.1-2

=== debian/changelog ===
supernovas (1.0.1-2-2) unstable; urgency=medium

  * Team upload.
    + Source-only Upload for testing migration.

 -- Nilesh Patra <nilesh@iki.fi>  Tue, 04 Jun 2024 01:29:14 +0530

supernovas (1.0.1-2-1) unstable; urgency=medium

  [ Attila Kovacs, Nilesh Patra ]

  * Initial release (Closes: #1071784)

 -- Attila Kovacs <attila.kovacs@cfa.harvard.edu>  Mon, 03 Jun 2024 02:25:15 +0530

=== debian/control ===
Source: supernovas
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Attila Kovacs <attila.kovacs@cfa.harvard.edu>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13)
Build-Depends-Indep: doxygen
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian-astro-team/supernovas
Vcs-Git: https://salsa.debian.org/debian-astro-team/supernovas.git
Homepage: https://smithsonian.github.io/SuperNOVAS
Rules-Requires-Root: no

Package: libsupernovas1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: libsupernovas-cio-data (= ${binary:Version})
Description: SuperNOVAS C/C++ astrometry library
 SuperNOVAS is a C/C++ astronomy library, providing high-precision astronomical
 calculations such as one might need for running an observatory or a precise
 planetarium program. It is a fork of the Naval Observatory Vector Astrometry
 Software (NOVAS) C version 3.1, providing bug fixes and making it easier to
 use overall.
 .
 The main goals of SuperNOVAS are to improve usability, add new features,
 promote best practices, and provide accessible documentation -- all while
 retaining 100% API compatibility with NOVAS C 3.1. Thus, if you have written
 code for NOVAS C 3.1, you can build it with SuperNOVAS also.
 SuperNOVAS is entirely free to use without licensing restrictions. Its source
 code is compatible with the C90 standard, and hence should be suitable for old
 and new platforms alike. It is light-weight and easy to use, with full support
 for the IAU 2000/2006 standards for sub-micro-arc-second position.

Package: libsolsys1-1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libsupernovas1 (= ${binary:Version})
Description: Legacy solar-system plugin for JPL DE200 through DE421
 Optional SuperNOVAS plugin library that provides legacy solar-system routines
 for accessing older JPL planetary data (DE200 through DE421).

Package: libsolsys2-1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libsupernovas1 (= ${binary:Version})
Description: Legacy solar-system plugin for the JPL PLEPH routines
 Optional SuperNOVAS plugin library that provides legacy solar-system routines
 for accessing older JPL planetary data through the JPL PLEPH routines. It
 requires a user-provided FORTRAN adapter module, and PLEPH library. This
 package is provided only to support legacy applications that were written for
 that particular interfacing.

Package: libsupernovas-cio-data
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}
Description: CIO location data for the SuperNOVAS C/C++ astronomy library
 Optional CIO location vs GCRS lookup table. This file is not normally
 required for the operation of the library. It is needed only if the user
 explicitly needs to know the location of the CIO vs GCRS, rather than w.r.t.
 the equinox of date.
 .
 Applications that require CIO location w.r.t. the GCRS should depend on this
 sub-package.
Build-Profiles: <!pkg.supernovas.ciodata>

Package: libsupernovas-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libsupernovas1 (= ${binary:Version}),
         libsolsys1-1 (= ${binary:Version}),
         libsolsys2-1 (= ${binary:Version})
Description: C development files for the SuperNOVAS C/C++ astronomy library
 This sub-package provides C headers and non-versioned shared library symbolic
 links for the SuperNOVAS C/C++ library.

Package: libsupernovas-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Documentation for the SuperNOVAS C/C++ astronomy library
 This package provides man pages and HTML documentation for the SuperNOVAS
 C/C++ astronomy library.

=== debian/rules ===
#!/usr/bin/make -f

CIO_LOCATOR_FILE=/usr/lib/${DEB_HOST_MULTIARCH}/supernovas/cio_ra.bin
BINPACKAGES := $(shell dh_listpackages)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	dh_auto_build
ifneq (,$(filter libsupernovas-cio-data,$(BINPACKAGES)))
	dh_auto_build -- cio_ra.bin
endif

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.md

## supernovas 1.1.0

=== Makefile ===
--- 
+++ 
@@ -57,7 +57,7 @@
 
 # Default target for packaging with Linux distributions
 .PHONY: distro
-distro: $(SHARED_TARGETS) cio_ra.bin $(DOC_TARGETS)
+distro: $(SHARED_TARGETS) $(DOC_TARGETS)
 
 # Shared libraries (versioned and unversioned)
 .PHONY: shared
@@ -116,7 +116,7 @@
 SO_LINK := $(LDFLAGS) -lm
 
 # Share librarry recipe
-lib/%.so.$(SO_VERSION) : | lib
+lib/%.so.$(SO_VERSION) : | lib Makefile
 	$(CC) -o $@ $(CPPFLAGS) $(CFLAGS) $^ -shared -fPIC -Wl,-soname,$(subst lib/,,$@) $(SO_LINK)
 
 lib/libsolsys%.so.$(SO_VERSION): SO_LINK += -Llib -lsupernovas
@@ -142,14 +142,13 @@
 
 
 # Static library: novas.a
-lib/libnovas.a: $(OBJECTS) | lib
+lib/libnovas.a: $(OBJECTS) | lib Makefile
 	ar -rc $@ $^
 	ranlib $@
 
 # CIO locator data
-.PHONY: cio_ra.bin
-cio_ra.bin: bin/cio_file lib/libnovas.a data/CIO_RA.TXT
-	bin/cio_file data/CIO_RA.TXT $@
+cio_ra.bin: data/CIO_RA.TXT bin/cio_file lib/libnovas.a
+	bin/cio_file $< $@
 
 .INTERMEDIATE: bin/cio_file
 bin/cio_file: obj/cio_file.o | bin
@@ -166,10 +165,10 @@
 
 # Local documentation without specialized headers. The resulting HTML documents do not have
 # Google Search or Analytics tracking info.
+.PHONY: local-dox
 local-dox: README-orig.md Doxyfile.local
 	doxygen Doxyfile.local
 
-
 .PHONY: help
 help:
 	@echo
@@ -177,17 +176,17 @@
 	@echo
 	@echo "The following targets are available:"
 	@echo
-	@echo "  distro        (default) 'shared', 'cio_ra.bin' targets, and also 'dox'" 
-	@echo "                if 'doxygen' is available, or was specified via the DOXYGEN"
-	@echo "                variable (e.g. in 'config.mk')."
+	@echo "  distro        (default) 'shared' targets and also 'local-dox' provided 'doxygen'" 
+	@echo "                is available, or was specified via the DOXYGEN variable (e.g. in"
+	@echo "                'config.mk')."
 	@echo "  static        Builds the static 'lib/libsupernovas.a' library."
 	@echo "  shared        Builds the shared 'libsupernovas.so', 'libsolsys1.so', and" 
 	@echo "                'libsolsys2.so' libraries (linked to versioned ones)."
-	@echo "  cio_ra.bin    Generates the CIO locator lookup data file 'cio_ra.bin', in the"
-	@echo "                destination specified in 'config.mk'."
 	@echo "  local-dox     Compiles local HTML API documentation using 'doxygen'."
 	@echo "  solsys        Builds only the objects that may provide external 'solarsystem()'"
 	@echo "                call implentations (e.g. 'solsys1.o', 'eph_manager.o'...)."
+	@echo "  cio_ra.bin    Generates a platform-specific binary CIO locator lookup data file"
+	@echo "                'cio_ra.bin' from the ASCII 'data/CIO_RA.TXT'."
 	@echo "  check         Performs static analysis with 'cppcheck'."
 	@echo "  test          Runs regression tests."
 	@echo "  coverage      Runs 'gcov' to analyze regression test coverage."

=== test/Makefile ===
--- 
+++ 
@@ -6,16 +6,16 @@
 # Use above config in sub-makes also
 export BUILTIN_SOLSYS3 BUILTIN_DEFAULT_SOLSYS CIO_LOCATOR_FILE
 
-CFLAGS += -I../include -g -pg -fprofile-arcs -ftest-coverage
+CFLAGS += -I../include -g -pg -Wall -fprofile-arcs -ftest-coverage
 LDFLAGS += -fprofile-arcs -ftest-coverage -lm
 
 include ../config.mk
 
 #OBJECTS := $(subst obj/,,$(OBJECTS))
-OBJECTS := novas.o nutation.o solsys3.o
+OBJECTS := novas.o nutation.o solsys3.o frames.o timescale.o refract.o
 
 .PHONY: run
-run: clean-cov clean-data test-compat test-cio_file test-super test-errors data ../cio_ra.bin
+run: clean-cov clean-data test-compat test-cio_file test-super test-errors data ../cio_ra.bin bad-data
 	./test-compat
 	ln -s ../cio_ra.bin
 	./test-cio_file
@@ -32,12 +32,28 @@
 	geninfo . -b . -o $@
 
 .PHONY: coverage
-coverage: novas.c.gcov nutation.c.gcov solsys3.c.gcov
+coverage: novas.c.gcov nutation.c.gcov solsys3.c.gcov timescale.c.gcov refract.c.gcov frames.c.gcov
 	make clean-test
 	make cov
 
 data:
 	mkdir data
+
+.PHONY: bad-data
+bad-data: ../cio_ra.bin bad-cio-data
+	@touch bad-cio-data/empty
+	@dd status=none if=../cio_ra.bin of=bad-cio-data/bad-1.bin bs=27 count=1
+	@dd status=none if=../cio_ra.bin of=bad-cio-data/bad-2.bin bs=63 count=1
+	@dd status=none if=../data/CIO_RA.TXT of=bad-cio-data/bad-1.txt bs=14 count=1
+	@dd status=none if=../data/CIO_RA.TXT of=bad-cio-data/bad-2.txt bs=79 count=1
+	@dd status=none if=../data/CIO_RA.TXT of=bad-cio-data/bad-3.txt bs=21 count=1
+	@dd status=none if=../data/CIO_RA.TXT of=bad-cio-data/bad-4.txt bs=21 count=1
+	@echo "blah" >> bad-cio-data/bad-4.txt
+	@dd status=none if=../data/CIO_RA.TXT of=bad-cio-data/bad-5.txt bs=79 count=1
+	@echo "blah blah blah blah blah blah" >> bad-cio-data/bad-5.txt
+
+bad-cio-data:
+	mkdir $@
 
 .PRECIOUS: %.c.gcov
 %.c.gcov: %.gcno %.gcda
@@ -70,12 +86,27 @@
 
 .PHONY: clean-data
 clean-data:
-	rm -rf data cio_ra.bin
+	rm -rf data cio_ra.bin bad-cio-data
 
 .PHONY: clean
 clean: clean-test clean-cov clean-data
 	rm -f *.o
 
+
+.PHONY: help
+help:
+	@echo
+	@echo "Syntax: make [target]"
+	@echo
+	@echo "The following targets are available:"
+	@echo
+	@echo "  run           (default) Compiles and runs regression tests."
+	@echo "  coverage      Extracts test coverage data."
+	@echo "  clean         Removes intermediate products."
+	@echo "  distclean     Deletes all generated files."
+	@echo
+
+
 vpath %.c ../src
 vpath %.c src

=== debian/changelog ===
supernovas (1.1.0-1) unstable; urgency=medium
  
  * Update to upstream SupeerNOVAS v1.1.0
  
 -- Attila Kovacs <attila.kovacs@cfa.harvard.edu>  Sat, 03 Aug 2024 16:49:00 +0200

=== debian/control ===
--- 
+++ 
@@ -60,8 +60,7 @@
  that particular interfacing.
 
 Package: libsupernovas-cio-data
-Architecture: any
-Multi-Arch: same
+Architecture: all
 Section: libs
 Depends: ${misc:Depends}
 Description: CIO location data for the SuperNOVAS C/C++ astronomy library

=== debian/rules ===
#!/usr/bin/make -f

CIO_LOCATOR_FILE=/usr/share/supernovas/CIO_RA.TXT
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.md

## supernovas 1.1.1

=== Makefile ===
--- 
+++ 
@@ -15,8 +15,8 @@
 # The version of the shared .so libraries
 SO_VERSION := 1
 
-# The documentation components to build
-DOC_TARGETS := README-orig.md
+# We'll need math functions to link
+LDFLAGS += -lm
 
 # Check if there is a doxygen we can run
 ifndef DOXYGEN
@@ -33,26 +33,26 @@
 endif
 
 SOLSYS_TARGETS :=
-SHARED_TARGETS := lib/libsupernovas.so lib/libnovas.so
+SHARED_TARGETS := $(LIB)/libsupernovas.so $(LIB)/libnovas.so
 
 ifneq ($(BUILTIN_SOLSYS1),1)
-  SOLSYS_TARGETS += obj/solsys1.o obj/eph_manager.o
-  SHARED_TARGETS += lib/libsolsys1.so
+  SOLSYS_TARGETS += $(OBJ)/solsys1.o $(OBJ)/eph_manager.o
+  SHARED_TARGETS += $(LIB)/libsolsys1.so
 endif
 
 ifneq ($(BUILTIN_SOLSYS2),1)
-  SOLSYS_TARGETS += obj/solsys2.o
-  SHARED_TARGETS += lib/libsolsys2.so
+  SOLSYS_TARGETS += $(OBJ)/solsys2.o
+  SHARED_TARGETS += $(LIB)/libsolsys2.so
 endif
 
 ifneq ($(BUILTIN_SOLSYS3),1)
-  SOLSYS_TARGETS += obj/solsys3.o
-  SHARED_TARGETS += lib/libsolsys3.so
+  SOLSYS_TARGETS += $(OBJ)/solsys3.o
+  SHARED_TARGETS += $(LIB)/libsolsys3.so
 endif
 
 ifneq ($(BUILTIN_SOLSYS_EPHEM),1)
-  SOLSYS_TARGETS += obj/solsys-ephem.o
-  SHARED_TARGETS += lib/libsolsys-ephem.so
+  SOLSYS_TARGETS += $(OBJ)/solsys-ephem.o
+  SHARED_TARGETS += $(LIB)/libsolsys-ephem.so
 endif
 
 # Default target for packaging with Linux distributions
@@ -65,7 +65,7 @@
 
 # Legacy static libraries (locally built)
 .PHONY: static
-static: lib/libnovas.a solsys
+static: $(LIB)/libnovas.a solsys
 
 # solarsystem() call handler objects
 .PHONY: solsys
@@ -88,70 +88,56 @@
 # Remove intermediates
 .PHONY: clean
 clean:
-	rm -f obj README-orig.md bin/cio_file gmon.out
+	rm -f $(OBJECTS) README-orig.md $(BIN)/cio_file gmon.out
 	make -C test clean
 
 # Remove all generated files
 .PHONY: distclean
 distclean: clean
-	rm -f lib cio_ra.bin
-
+	rm -f $(LIB)/libsupernovas.so* $(LIB)/libnovas.so* $(LIB)/libnovas.a $(LIB)/libsolsys*.so* cio_ra.bin
 
 # ----------------------------------------------------------------------------
 # The nitty-gritty stuff below
 # ----------------------------------------------------------------------------
 
-# Unversioned shared libs (for linking against)
-lib/lib%.so:
-	ln -sr $< $@
+$(LIB)/libsupernovas.so: $(LIB)/libsupernovas.so.$(SO_VERSION)
 
-lib/libsupernovas.so: lib/libsupernovas.so.$(SO_VERSION)
+$(LIB)/libsolsys1.so: $(LIB)/libsolsys1.so.$(SO_VERSION)
 
-lib/libsolsys1.so: lib/libsolsys1.so.$(SO_VERSION)
+$(LIB)/libsolsys2.so: $(LIB)/libsolsys2.so.$(SO_VERSION)
 
-lib/libsolsys2.so: lib/libsolsys2.so.$(SO_VERSION)
+$(LIB)/libnovas.so: $(LIB)/libsupernovas.so
 
-lib/libnovas.so: lib/libsupernovas.so
+$(LIB)/libsolsys%.so.$(SO_VERSION): LDFLAGS += -L$(LIB) -lsupernovas
 
-SO_LINK := $(LDFLAGS) -lm
+# Shared library: libsupernovas.so.1 -- same as novas.so except the builtin SONAME
+$(LIB)/libsupernovas.so.$(SO_VERSION): $(SOURCES)
 
-# Share librarry recipe
-lib/%.so.$(SO_VERSION) : | lib Makefile
-	$(CC) -o $@ $(CPPFLAGS) $(CFLAGS) $^ -shared -fPIC -Wl,-soname,$(subst lib/,,$@) $(SO_LINK)
+# Shared library: libsolsys1.so.1 (standalone solsys1.c functionality)
+$(LIB)/libsolsys1.so.$(SO_VERSION): BUILTIN_SOLSYS1 := 0
+$(LIB)/libsolsys1.so.$(SO_VERSION): $(SRC)/solsys1.c $(SRC)/eph_manager.c | $(LIB)/libsupernovas.so
 
-lib/libsolsys%.so.$(SO_VERSION): SO_LINK += -Llib -lsupernovas
+# Shared library: libsolsys2.so.1 (standalone solsys2.c functionality)
+$(LIB)/libsolsys2.so.$(SO_VERSION): BUILTIN_SOLSYS2 := 0
+$(LIB)/libsolsys2.so.$(SO_VERSION): $(SRC)/solsys2.c | $(LIB)/libsupernovas.so
 
-# Shared library: supernovas.so -- same as novas.so except the builtin SONAME
-lib/libsupernovas.so.$(SO_VERSION): $(SOURCES)
+# Shared library: libsolsys3.so.1 (standalone solsys1.c functionality)
+$(LIB)/libsolsys3.so.$(SO_VERSION): BUILTIN_SOLSYS3 := 0
+$(LIB)/libsolsys3.so.$(SO_VERSION): $(SRC)/solsys3.c | $(LIB)/libsupernovas.so
 
-# Shared library: solsys1.so (standalone solsys1.c functionality)
-lib/libsolsys1.so.$(SO_VERSION): BUILTIN_SOLSYS1 := 0
-lib/libsolsys1.so.$(SO_VERSION): $(SRC)/solsys1.c $(SRC)/eph_manager.c | lib/libsupernovas.so
+# Shared library: libsolsys-ephem.so.1 (standalone solsys2.c functionality)
+$(LIB)/libsolsys-ephem.so.$(SO_VERSION): BUILTIN_SOLSYS_EPHEM := 0
+$(LIB)/libsolsys-ephem.so.$(SO_VERSION): $(SRC)/solsys-ephem.c | $(LIB)/libsupernovas.so
 
-# Shared library: solsys2.so (standalone solsys2.c functionality)
-lib/libsolsys2.so.$(SO_VERSION): BUILTIN_SOLSYS2 := 0
-lib/libsolsys2.so.$(SO_VERSION): $(SRC)/solsys2.c | lib/libsupernovas.so
-
-# Shared library: solsys1.so (standalone solsys1.c functionality)
-lib/libsolsys3.so.$(SO_VERSION): BUILTIN_SOLSYS3 := 0
-lib/libsolsys3.so.$(SO_VERSION): $(SRC)/solsys3.c | lib/libsupernovas.so
-
-# Shared library: solsys2.so (standalone solsys2.c functionality)
-lib/libsolsys-ephem.so.$(SO_VERSION): BUILTIN_SOLSYS_EPHEM := 0
-lib/libsolsys-ephem.so.$(SO_VERSION): $(SRC)/solsys-ephem.c | lib/libsupernovas.so
-
-
-# Static library: novas.a
-lib/libnovas.a: $(OBJECTS) | lib Makefile
-	ar -rc $@ $^
-	ranlib $@
+# Static library: libnovas.a
+$(LIB)/libnovas.a: $(OBJECTS) | $(LIB) Makefile
 
 # CIO locator data
-cio_ra.bin: data/CIO_RA.TXT bin/cio_file lib/libnovas.a
-	bin/cio_file $< $@
+cio_ra.bin: data/CIO_RA.TXT $(BIN)/cio_file
+	$(BIN)/cio_file $< $@
 
-.INTERMEDIATE: bin/cio_file
-bin/cio_file: obj/cio_file.o | bin
+.INTERMEDIATE: $(BIN)/cio_file
+bin/cio_file: $(OBJ)/cio_file.o | $(BIN)
 	$(CC) -o $@ $(CPPFLAGS) $(CFLAGS) $^ $(LDFLAGS)
 
 README-orig.md: README.md
@@ -160,7 +146,7 @@
 dox: README-orig.md
 
 .INTERMEDIATE: Doxyfile.local
-Doxyfile.local:
+Doxyfile.local: Doxyfile Makefile
 	sed "s:resources/header.html::g" Doxyfile > $@
 
 # Local documentation without specialized headers. The resulting HTML documents do not have
@@ -169,6 +155,7 @@
 local-dox: README-orig.md Doxyfile.local
 	doxygen Doxyfile.local
 
+# Built-in help screen for `make help`
 .PHONY: help
 help:
 	@echo
@@ -195,9 +182,8 @@
 	@echo "  distclean     Deletes all generated files."
 	@echo
 
+# This Makefile depends on the config and build snipplets.
 Makefile: config.mk build.mk
-
-vpath %.c $(SRC)
 
 # ===============================================================================
 # Generic targets and recipes below...

=== test/Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 include ../config.mk
 
 #OBJECTS := $(subst obj/,,$(OBJECTS))
-OBJECTS := novas.o nutation.o solsys3.o frames.o timescale.o refract.o
+OBJECTS := novas.o nutation.o solsys3.o super.o frames.o timescale.o refract.o
 
 .PHONY: run
 run: clean-cov clean-data test-compat test-cio_file test-super test-errors data ../cio_ra.bin bad-data
@@ -32,7 +32,7 @@
 	geninfo . -b . -o $@
 
 .PHONY: coverage
-coverage: novas.c.gcov nutation.c.gcov solsys3.c.gcov timescale.c.gcov refract.c.gcov frames.c.gcov
+coverage: novas.c.gcov nutation.c.gcov solsys3.c.gcov super.c.gcov timescale.c.gcov refract.c.gcov frames.c.gcov
 	make clean-test
 	make cov
 
@@ -92,7 +92,6 @@
 clean: clean-test clean-cov clean-data
 	rm -f *.o
 
-
 .PHONY: help
 help:
 	@echo

=== debian/changelog ===
supernovas (1.1.1-2) unstable; urgency=medium

  * Test without excessive precision

 -- Attila Kovacs <attila.kovacs@cfa.harvard.edu>  Thu, 31 Oct 2024 19:10:48 +0530

supernovas (1.1.1-1) unstable; urgency=medium

  * Update to upstream SuperNOVAS v1.1.1

 -- Attila Kovacs <attila.kovacs@cfa.harvard.edu>  Wed, 30 Oct 2024 19:11:37 +0530

=== debian/control ===
--- 
+++ 
@@ -71,7 +71,6 @@
  .
  Applications that require CIO location w.r.t. the GCRS should depend on this
  sub-package.
-Build-Profiles: <!pkg.supernovas.ciodata>
 
 Package: libsupernovas-dev
 Architecture: any

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%supernovas-$1.tar.gz%" \
   https://github.com/Smithsonian/SuperNOVAS/tags \
   .*?@ANY_VERSION@@ARCHIVE_EXT@

## supernovas 1.2.0

=== Makefile ===
--- 
+++ 
@@ -55,17 +55,29 @@
   SHARED_TARGETS += $(LIB)/libsolsys-ephem.so
 endif
 
+ifeq ($(CALCEPH_SUPPORT),1)
+  CPPFLAGS += -DUSE_CALCEPH=1
+  SOLSYS_TARGETS += $(OBJ)/solsys-calceph.o
+  SHARED_TARGETS += $(LIB)/libsolsys-calceph.so
+endif
+
+ifeq ($(CSPICE_SUPPORT),1)
+  CPPFLAGS += -DUSE_CSPICE=1
+  SOLSYS_TARGETS += $(OBJ)/solsys-cspice.o
+  SHARED_TARGETS += $(LIB)/libsolsys-cspice.so
+endif
+
 # Default target for packaging with Linux distributions
 .PHONY: distro
 distro: $(SHARED_TARGETS) $(DOC_TARGETS)
 
 # Shared libraries (versioned and unversioned)
 .PHONY: shared
-shared: $(SHARED_TARGETS)
+shared: check-cio-locator $(SHARED_TARGETS)
 
 # Legacy static libraries (locally built)
 .PHONY: static
-static: $(LIB)/libnovas.a solsys
+static: check-cio-locator $(LIB)/libnovas.a solsys
 
 # solarsystem() call handler objects
 .PHONY: solsys
@@ -73,28 +85,39 @@
 
 # All of the above
 .PHONY: all
-all: distro static test coverage check
+all: distro static test coverage analyze
 
 # Run regression tests
 .PHONY: test
 test:
-	make -C test run
+	$(MAKE) -C test run
+
+# Perform checks (test + analyze)
+.PHONY: check
+check: test analyze
 
 # Measure test coverage (on test set of files only)
 .PHONY: coverage
 coverage:
-	make -C test coverage
+	$(MAKE) -C test coverage
 
 # Remove intermediates
 .PHONY: clean
 clean:
 	rm -f $(OBJECTS) README-orig.md $(BIN)/cio_file gmon.out
-	make -C test clean
+	$(MAKE) -C test clean
 
 # Remove all generated files
 .PHONY: distclean
 distclean: clean
-	rm -f $(LIB)/libsupernovas.so* $(LIB)/libnovas.so* $(LIB)/libnovas.a $(LIB)/libsolsys*.so* cio_ra.bin
+	rm -f $(LIB)/libsupernovas.so* $(LIB)/libsupernovas.a $(LIB)/libnovas.so* $(LIB)/libnovas.a $(LIB)/libsolsys*.so* cio_ra.bin
+
+.PHONY:
+check-cio-locator:
+ifndef CIO_LOCATOR_FILE
+	  $(info WARNING! No default CIO_LOCATOR_FILE defined. Will use local 'cio_ra.bin' if present.)
+endif
+
 
 # ----------------------------------------------------------------------------
 # The nitty-gritty stuff below
@@ -106,6 +129,14 @@
 
 $(LIB)/libsolsys2.so: $(LIB)/libsolsys2.so.$(SO_VERSION)
 
+$(LIB)/libsolsys3.so: $(LIB)/libsolsys2.so.$(SO_VERSION)
+
+$(LIB)/libsolsys-ephem.so: $(LIB)/libsolsys-ephem.so.$(SO_VERSION)
+
+$(LIB)/libsolsys-calceph.so: $(LIB)/libsolsys-calceph.so.$(SO_VERSION)
+
+$(LIB)/libsolsys-cspice.so: $(LIB)/libsolsys-cspice.so.$(SO_VERSION)
+
 $(LIB)/libnovas.so: $(LIB)/libsupernovas.so
 
 $(LIB)/libsolsys%.so.$(SO_VERSION): LDFLAGS += -L$(LIB) -lsupernovas
@@ -129,8 +160,20 @@
 $(LIB)/libsolsys-ephem.so.$(SO_VERSION): BUILTIN_SOLSYS_EPHEM := 0
 $(LIB)/libsolsys-ephem.so.$(SO_VERSION): $(SRC)/solsys-ephem.c | $(LIB)/libsupernovas.so
 
-# Static library: libnovas.a
-$(LIB)/libnovas.a: $(OBJECTS) | $(LIB) Makefile
+# Shared library: libsolsys-calceph.so.1 (standalone solsys2.c functionality)
+$(LIB)/libsolsys-calceph.so.$(SO_VERSION): LDFLAGS += -lcalceph
+$(LIB)/libsolsys-calceph.so.$(SO_VERSION): $(SRC)/solsys-calceph.c | $(LIB)/libsupernovas.so
+
+# Shared library: libsolsys-cspice.so.1 (standalone solsys2.c functionality)
+$(LIB)/libsolsys-cspice.so.$(SO_VERSION): LDFLAGS += -lcspice
+$(LIB)/libsolsys-cspice.so.$(SO_VERSION): $(SRC)/solsys-cspice.c | $(LIB)/libsupernovas.so
+
+# Static library: libsupernovas.a
+$(LIB)/libsupernovas.a: $(OBJECTS) | $(LIB) Makefile
+
+$(LIB)/libnovas.a: $(LIB)/libsupernovas.a
+	@rm -f $@
+	( cd $(LIB); ln -s libsupernovas.a libnovas.a )
 
 # CIO locator data
 cio_ra.bin: data/CIO_RA.TXT $(BIN)/cio_file
@@ -154,6 +197,85 @@
 .PHONY: local-dox
 local-dox: README-orig.md Doxyfile.local
 	doxygen Doxyfile.local
+
+# Default values for install locations
+# See https://www.gnu.org/prep/standards/html_node/Directory-Variables.html 
+prefix ?= /usr
+exec_prefix ?= $(prefix)
+libdir ?= $(exec_prefix)/lib
+includedir ?= $(prefix)/include
+datarootdir ?= $(prefix)/share
+datadir ?= $(datarootdir)
+mydatadir ?= $(datadir)/supernovas
+docdir ?= $(datarootdir)/doc/supernovas
+htmldir ?= $(docdir)/html
+
+# Standard install commands
+INSTALL_PROGRAM ?= install
+INSTALL_DATA ?= install -m 644
+
+.PHONY: install
+install: install-libs install-cio-data install-headers install-html install-examples
+
+.PHONY: install-libs
+install-libs:
+ifneq ($(wildcard $(LIB)/*),)
+	@echo "installing libraries to $(DESTDIR)$(libdir)"
+	install -d $(DESTDIR)$(libdir)
+	cp -a $(LIB)/lib* $(DESTDIR)$(libdir)/
+else
+	@echo "WARNING! Skipping libs install: needs 'shared' and/or 'static'"
+endif
+
+.PHONY: install-cio-data
+install-cio-data:
+	@echo "installing CIO locator data to $(DESTDIR)$(mydatadir)"
+	install -d $(DESTDIR)$(mydatadir)
+	$(INSTALL_DATA) data/CIO_RA.TXT $(DESTDIR)$(mydatadir)/CIO_RA.TXT
+
+.PHONY: install-headers
+install-headers:
+	@echo "installing headers to $(DESTDIR)$(includedir)"
+	install -d $(DESTDIR)$(includedir)
+	$(INSTALL_DATA) -D include/* $(DESTDIR)$(includedir)/
+
+.PHONY: install-html
+install-html:
+ifneq ($(wildcard apidoc/html/search/*),)
+	@echo "installing API documentation to $(DESTDIR)$(htmldir)"
+	install -d $(DESTDIR)$(htmldir)/search
+	$(INSTALL_DATA) -D apidoc/html/search/* $(DESTDIR)$(htmldir)/search/
+	$(INSTALL_DATA) -D apidoc/html/*.* $(DESTDIR)$(htmldir)/
+	@echo "installing images to $(DESTDIR)$(htmldir)/resources"
+	install -d $(DESTDIR)$(htmldir)/resources
+	$(INSTALL_DATA) -D resources/SuperNOVAS-systems.png $(DESTDIR)$(htmldir)/resources/
+	@echo "installing Doxygen tag file to $(DESTDIR)$(docdir)"
+	install -d $(DESTDIR)$(docdir)
+	$(INSTALL_DATA) apidoc/supernovas.tag $(DESTDIR)$(docdir)/supernovas.tag
+else
+	@echo "WARNING! Skipping apidoc install: needs doxygen and 'local-dox'"
+endif
+
+.PHONY: install-examples
+install-examples:
+	@echo "installing examples to $(DESTDIR)$(docdir)"
+	install -d $(DESTDIR)$(docdir)
+	$(INSTALL_DATA) -D examples/* $(DESTDIR)$(docdir)/
+
+
+# Some standard GNU targets, that should always exist...
+.PHONY: html
+html: local-dox
+
+.PHONY: dvi
+dvi:
+
+.PHONY: ps
+ps:
+
+.PHONY: pdf
+pdf:
+
 
 # Built-in help screen for `make help`
 .PHONY: help
@@ -174,10 +296,12 @@
 	@echo "                call implentations (e.g. 'solsys1.o', 'eph_manager.o'...)."
 	@echo "  cio_ra.bin    Generates a platform-specific binary CIO locator lookup data file"
 	@echo "                'cio_ra.bin' from the ASCII 'data/CIO_RA.TXT'."
-	@echo "  check         Performs static analysis with 'cppcheck'."
 	@echo "  test          Runs regression tests."
+	@echo "  analyze       Performs static code analysis with 'cppcheck'."
+	@echo "  check         Same as 'test' and then 'analyze'."
 	@echo "  coverage      Runs 'gcov' to analyze regression test coverage."
 	@echo "  all           All of the above."
+	@echo "  install       Install components (e.g. 'make prefix=<path> install')"
 	@echo "  clean         Removes intermediate products."
 	@echo "  distclean     Deletes all generated files."
 	@echo

=== test/Makefile ===
--- 
+++ 
@@ -6,16 +6,32 @@
 # Use above config in sub-makes also
 export BUILTIN_SOLSYS3 BUILTIN_DEFAULT_SOLSYS CIO_LOCATOR_FILE
 
-CFLAGS += -I../include -g -pg -Wall -fprofile-arcs -ftest-coverage
+CFLAGS += -I../include -pg -Wall -fprofile-arcs -ftest-coverage
 LDFLAGS += -fprofile-arcs -ftest-coverage -lm
 
 include ../config.mk
 
 #OBJECTS := $(subst obj/,,$(OBJECTS))
-OBJECTS := novas.o nutation.o solsys3.o super.o frames.o timescale.o refract.o
+OBJECTS := novas.o nutation.o solsys3.o super.o frames.o timescale.o refract.o naif.o
+TESTS := test-compat test-cio_file test-super test-errors
+COVFILES := novas.c.gcov nutation.c.gcov solsys3.c.gcov super.c.gcov timescale.c.gcov refract.c.gcov frames.c.gcov naif.c.gcov
+
+ifeq ($(CALCEPH_SUPPORT), 1)
+  LDFLAGS += -lcalceph
+  OBJECTS += solsys-calceph.o
+  TESTS += test-calceph
+  COVFILES += solsys-calceph.c.gcov
+endif
+
+ifeq ($(CSPICE_SUPPORT), 1)
+  LDFLAGS += -lcspice
+  OBJECTS += solsys-cspice.o
+  TESTS += test-cspice
+  COVFILES += solsys-cspice.c.gcov
+endif
 
 .PHONY: run
-run: clean-cov clean-data test-compat test-cio_file test-super test-errors data ../cio_ra.bin bad-data
+run: clean-cov clean-data $(TESTS) data ../cio_ra.bin bad-data
 	./test-compat
 	ln -s ../cio_ra.bin
 	./test-cio_file
@@ -24,6 +40,12 @@
 	./test-super
 	rm -f cio_ra.bin
 	./test-errors
+ifeq ($(CALCEPH_SUPPORT), 1)
+	./test-calceph ephem
+endif
+ifeq ($(CSPICE_SUPPORT), 1)
+	./test-cspice ephem
+endif
 
 cov: cov.info
 	genhtml $< -o $@
@@ -32,9 +54,10 @@
 	geninfo . -b . -o $@
 
 .PHONY: coverage
-coverage: novas.c.gcov nutation.c.gcov solsys3.c.gcov super.c.gcov timescale.c.gcov refract.c.gcov frames.c.gcov
-	make clean-test
-	make cov
+
+coverage: $(COVFILES)
+	$(MAKE) clean-test
+	$(MAKE) cov
 
 data:
 	mkdir data
@@ -61,11 +84,11 @@
 
 .PRECIOUS: %.gcno %.gcda
 %.gcno %.gcda: ../src/%.c
-	make clean
-	make run
+	$(MAKE) clean
+	$(MAKE) run
 
 ../cio_ra.bin:
-	make -C .. cio_ra.bin
+	$(MAKE) -C .. cio_ra.bin
 
 test-%: test-%.o $(OBJECTS) | Makefile data
 	$(CC) -o $@ $^ $(LDFLAGS)
@@ -75,6 +98,11 @@
 
 %.o: ../src/%.c | Makefile
 	$(CC) -c -o $@ $(CPPFLAGS) $(CFLAGS) $<
+
+
+test-calceph: LDFLAGS += -lcalceph
+
+test-cspice: LDFLAGS += -lcspice
 
 .PHONY: clean-test
 clean-test:

=== debian/changelog ===
supernovas (1.2.0-2) unstable; urgency=low

  * Version bump only

 -- Attila Kovacs <attila.kovacs@cfa.harvard.edu>  Mon, 03 Feb 2025 10:19:00 -0400

supernovas (1.2.0-1) unstable; urgency=medium

  * Update to upstream SuperNOVAS v1.2.0
  * Patches from 1.1.1 no longer needed, due to fix upstream. Removed.
  * Added libsolsys-calceph1 subpackage
  * Updated debian/*.sybmols with additions for v1.2.0
  * changed debian/*.install to use staging of 1.2.0 instead of build location
  * Updated watch file to process -rc release candidates correctly

 -- Attila Kovacs <attila.kovacs@cfa.harvard.edu>  Wed, 15 Jan 2025 13:51:00 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Attila Kovacs <attila.kovacs@cfa.harvard.edu>
 Section: devel
 Priority: optional
-Build-Depends: debhelper-compat (= 13)
+Build-Depends: debhelper-compat (= 13), libcalceph-dev
 Build-Depends-Indep: doxygen
 Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/supernovas
@@ -33,6 +33,21 @@
  code is compatible with the C90 standard, and hence should be suitable for old
  and new platforms alike. It is light-weight and easy to use, with full support
  for the IAU 2000/2006 standards for sub-micro-arc-second position.
+
+Package: libsolsys-calceph1
+Architecture: any
+Multi-Arch: same
+Section: libs
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         libsupernovas1 (= ${binary:Version}),
+         libcalceph2
+Description: Optional SuperNOVAS plugin library that provides Solar-system 
+ support via the CALCEPH C library. It allows using both JPL (SPK) and INPOP 
+ 2.0/3.0 data files with SuperNOVAS to obtain precise locations for 
+ Solar-system bodies. This plugin is currently the preferred option to use for
+ Fedora / RPM Linux development, which requires use of precise Solar-system 
+ data.
 
 Package: libsolsys1-1
 Architecture: any
@@ -78,6 +93,7 @@
 Section: libdevel
 Depends: ${misc:Depends},
          libsupernovas1 (= ${binary:Version}),
+         libsolsys-calceph1 (= ${binary:Version}),
          libsolsys1-1 (= ${binary:Version}),
          libsolsys2-1 (= ${binary:Version})
 Description: C development files for the SuperNOVAS C/C++ astronomy library

=== debian/rules ===
#!/usr/bin/make -f

export CIO_LOCATOR_FILE=/usr/share/supernovas/CIO_RA.TXT
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.md

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%supernovas-$1.tar.gz%, \
uversionmangle=s:(\d)-rc(\d*):$1~rc$2:" \
   https://github.com/Smithsonian/SuperNOVAS/tags \
   .*?@ANY_VERSION@@ARCHIVE_EXT@

## supernovas 1.3.0

=== Makefile ===
--- 
+++ 
@@ -29,7 +29,9 @@
 ifeq ($(.SHELLSTATUS),0)
   DOC_TARGETS += local-dox
 else
-  $(info WARNING! Doxygen is not available. Will skip 'dox' target) 
+  ifneq ($(DOXYGEN),none)
+    $(info WARNING! Doxygen is not available. Will skip 'dox' target)
+  endif
 endif
 
 SOLSYS_TARGETS :=
@@ -89,8 +91,12 @@
 
 # Run regression tests
 .PHONY: test
-test:
+test: cio_ra.bin
 	$(MAKE) -C test run
+
+.PHONY: benchmark
+benchmark: shared
+	$(MAKE) LD_LIBRARY_PATH=$(shell pwd)/$(LIB) -C benchmark
 
 # Perform checks (test + analyze)
 .PHONY: check
@@ -106,11 +112,13 @@
 clean:
 	rm -f $(OBJECTS) README-orig.md $(BIN)/cio_file gmon.out
 	$(MAKE) -C test clean
+	$(MAKE) -C benchmark clean
 
 # Remove all generated files
 .PHONY: distclean
 distclean: clean
 	rm -f $(LIB)/libsupernovas.so* $(LIB)/libsupernovas.a $(LIB)/libnovas.so* $(LIB)/libnovas.a $(LIB)/libsolsys*.so* cio_ra.bin
+	$(MAKE) -C benchmark distclean
 
 .PHONY:
 check-cio-locator:
@@ -186,7 +194,16 @@
 README-orig.md: README.md
 	LINE=`sed -n '/\# /{=;q;}' $<` && tail -n +$$((LINE+2)) $< > $@
 
-dox: README-orig.md
+
+dox: 
+
+# Doxygen documentation (HTML and man pages) under apidocs/
+.PHONY: dox
+dox: README.md Doxyfile apidoc $(SRC) $(INC) README-orig.md
+	@echo "   [doxygen]"
+	@$(DOXYGEN)
+	@rm -f apidoc/html/resources
+	@( cd apidoc/html; rm -f resources; ln -s ../../resources )
 
 .INTERMEDIATE: Doxyfile.local
 Doxyfile.local: Doxyfile Makefile
@@ -196,7 +213,8 @@
 # Google Search or Analytics tracking info.
 .PHONY: local-dox
 local-dox: README-orig.md Doxyfile.local
-	doxygen Doxyfile.local
+	$(DOXYGEN) Doxyfile.local
+	( cd apidoc/html; rm -f resources; ln -s ../../resources )
 
 # Default values for install locations
 # See https://www.gnu.org/prep/standards/html_node/Directory-Variables.html 
@@ -215,14 +233,14 @@
 INSTALL_DATA ?= install -m 644
 
 .PHONY: install
-install: install-libs install-cio-data install-headers install-html install-examples
+install: install-libs install-cio-data install-headers install-html
 
 .PHONY: install-libs
 install-libs:
 ifneq ($(wildcard $(LIB)/*),)
 	@echo "installing libraries to $(DESTDIR)$(libdir)"
 	install -d $(DESTDIR)$(libdir)
-	cp -a $(LIB)/lib* $(DESTDIR)$(libdir)/
+	cp -a $(LIB)/* $(DESTDIR)$(libdir)/
 else
 	@echo "WARNING! Skipping libs install: needs 'shared' and/or 'static'"
 endif
@@ -255,13 +273,6 @@
 else
 	@echo "WARNING! Skipping apidoc install: needs doxygen and 'local-dox'"
 endif
-
-.PHONY: install-examples
-install-examples:
-	@echo "installing examples to $(DESTDIR)$(docdir)"
-	install -d $(DESTDIR)$(docdir)
-	$(INSTALL_DATA) -D examples/* $(DESTDIR)$(docdir)/
-
 
 # Some standard GNU targets, that should always exist...
 .PHONY: html
@@ -297,6 +308,7 @@
 	@echo "  cio_ra.bin    Generates a platform-specific binary CIO locator lookup data file"
 	@echo "                'cio_ra.bin' from the ASCII 'data/CIO_RA.TXT'."
 	@echo "  test          Runs regression tests."
+	@echo "  benchmark     Runs benchmarks."
 	@echo "  analyze       Performs static code analysis with 'cppcheck'."
 	@echo "  check         Same as 'test' and then 'analyze'."
 	@echo "  coverage      Runs 'gcov' to analyze regression test coverage."

=== benchmark/Makefile ===
CC ?= gcc
CFLAGS ?= -O2 -Wall -I../include

BENCHMARKS = benchmark-nutation benchmark-place

.PHONY: run
run: all
	@for prog in $(BENCHMARKS) ; do ./$${prog} ; done

.PHONY: all
all: $(BENCHMARKS)

benchmark-%: benchmark-%.c
	$(CC) -o $@ $^ $(CFLAGS) $(LDFLAGS) -L../lib -lsupernovas -lm

.PHONY: clean
clean:
	@rm -f *.o

.PHONY: distclean
distclean: clean
	@rm -f $(BENCHMARKS)

=== test/Makefile ===
--- 
+++ 
@@ -6,15 +6,20 @@
 # Use above config in sub-makes also
 export BUILTIN_SOLSYS3 BUILTIN_DEFAULT_SOLSYS CIO_LOCATOR_FILE
 
+include ../config.mk
+
 CFLAGS += -I../include -pg -Wall -fprofile-arcs -ftest-coverage
 LDFLAGS += -fprofile-arcs -ftest-coverage -lm
 
-include ../config.mk
+# cppcheck options for 'check' target. You can add additional options by
+# setting the CHECKEXTRA variable (e.g. in shell) prior to invoking 'make'.
+CHECKOPTS = --enable=performance,warning,portability --language=c \
+            --error-exitcode=1 --std=c99 --inline-suppr $(CHECKEXTRA)
 
-#OBJECTS := $(subst obj/,,$(OBJECTS))
-OBJECTS := novas.o nutation.o solsys3.o super.o frames.o timescale.o refract.o naif.o
+OBJECTS := $(subst $(OBJ)/,,$(OBJECTS))
+COVFILES := $(subst .o,.c.gcov,$(OBJECTS))
+
 TESTS := test-compat test-cio_file test-super test-errors
-COVFILES := novas.c.gcov nutation.c.gcov solsys3.c.gcov super.c.gcov timescale.c.gcov refract.c.gcov frames.c.gcov naif.c.gcov
 
 ifeq ($(CALCEPH_SUPPORT), 1)
   LDFLAGS += -lcalceph
@@ -87,9 +92,6 @@
 	$(MAKE) clean
 	$(MAKE) run
 
-../cio_ra.bin:
-	$(MAKE) -C .. cio_ra.bin
-
 test-%: test-%.o $(OBJECTS) | Makefile data
 	$(CC) -o $@ $^ $(LDFLAGS)
 
@@ -103,6 +105,12 @@
 test-calceph: LDFLAGS += -lcalceph
 
 test-cspice: LDFLAGS += -lcspice
+
+# Static code analysis using 'cppcheck'
+.PHONY: analyze
+analyze:
+	@echo "   [analyze]"
+	@cppcheck $(CPPFLAGS) $(CHECKOPTS) $(SRC)
 
 .PHONY: clean-test
 clean-test:
@@ -129,6 +137,7 @@
 	@echo
 	@echo "  run           (default) Compiles and runs regression tests."
 	@echo "  coverage      Extracts test coverage data."
+	@echo "  analyze       Static analysis with cppcheck."
 	@echo "  clean         Removes intermediate products."
 	@echo "  distclean     Deletes all generated files."
 	@echo

=== debian/changelog ===
supernovas (1.3.0-2) unstable; urgency=medium

  * team upload
  * upload to unstable
    (fixes soname status)

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 04 May 2025 23:30:21 +0200

supernovas (1.3.0-1) experimental; urgency=medium

  * Update to upstream SuperNOVAS v1.3.0
  * Legacy examples under legacy/ folder
  * Add patch for novas_sep() sqrt() range check
  * Trailing spaces; bump standards to 4.7.2
  * Patch for testing ira_equinox()

 -- Attila Kovacs <attipaci@gmail.com>  Tue, 15 Apr 2025 17:30:21 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13), libcalceph-dev
 Build-Depends-Indep: doxygen
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/supernovas
 Vcs-Git: https://salsa.debian.org/debian-astro-team/supernovas.git
 Homepage: https://smithsonian.github.io/SuperNOVAS
@@ -42,11 +42,11 @@
          ${misc:Depends},
          libsupernovas1 (= ${binary:Version}),
          libcalceph2
-Description: Optional SuperNOVAS plugin library that provides Solar-system 
- support via the CALCEPH C library. It allows using both JPL (SPK) and INPOP 
- 2.0/3.0 data files with SuperNOVAS to obtain precise locations for 
+Description: Optional SuperNOVAS plugin library that provides Solar-system
+ support via the CALCEPH C library. It allows using both JPL (SPK) and INPOP
+ 2.0/3.0 data files with SuperNOVAS to obtain precise locations for
  Solar-system bodies. This plugin is currently the preferred option to use for
- Fedora / RPM Linux development, which requires use of precise Solar-system 
+ Fedora / RPM Linux development, which requires use of precise Solar-system
  data.
 
 Package: libsolsys1-1

## supernovas 1.4.0

=== debian/changelog ===
supernovas (1.4.0-1) experimental; urgency=medium

  * Add new debian symbols 
  * Update to upstream SuperNOVAS v1.4.0 

 -- Attila Kovacs <attipaci@gmail.com>  Mon, 02 Jun 2025 08:11:45 +0200

supernovas (1.3.1-1) unstable; urgency=high

  * Update to upstream SuperNOVAS v1.3.1 (fixes accuracy bug)
  * Remove patches, which have been incorporated upstream

 -- Attila Kovacs <attipaci@gmail.com>  Wed, 07 May 2025 09:10:00 +0200
